#ifndef _STATUS_H
#define _STATUS_H

#include <kdialogbase.h>
#include <klistview.h>
#include <qdns.h>
#include <qmap.h>
#include <qobject.h>
#include <qdatetime.h>

class QTimer;
class FloodcastPlugin;
class QSocket;
class QHostAddress;
class QPopupMenu;

class HostItem : public QObject, public KListViewItem {
  Q_OBJECT
  public:
	HostItem(KListView *parent, const QHostAddress &);
	virtual ~HostItem();

  protected:
	QHostAddress _address;
	QDns *_async_lookup;	
	QDateTime _connect_time;
	QTimer *_update_timer;

  protected slots:
	void updateTime();
	void lookupComplete();
};

class FloodcastStatus : public KDialogBase {
  Q_OBJECT
  public:
	FloodcastStatus(FloodcastPlugin *parent);

  protected:
	void buildUI();
	
	FloodcastPlugin *_daddy;
	KListView *_list_view;

  protected slots:
	void gainedConnection(QSocket *);
	void lostConnection(QSocket *);

	void showContextMenu(QListViewItem *, const QPoint &pos);
	void disconnectClient();

  protected:
	QMap<QSocket *, HostItem *> _entry_map;
	QPopupMenu *_context_menu;
};

#endif
